CREATE TABLE advogado (
    oab                 varchar2(8)   NOT NULL,
    nome                varchar2(200) NOT NULL,
    PRIMARY KEY (oab)
);

CREATE TABLE endereco (
    id                 integer       NOT NULL ,
    rua                varchar2(200) NOT NULL,
    bairro             varchar2(15),
    numero             integer,
    cidade             varchar2(200),
    estado             varchar2(2),
    PRIMARY KEY (id)
);

CREATE TABLE reclamante (
    cpf                 varchar2(11)  NOT NULL,
    nome                varchar2(200) NOT NULL,
    oab_advogado        varchar2(8)           ,
    id_endereco         integer       NOT NULL,
    PRIMARY KEY (cpf)
);
ALTER TABLE reclamante ADD (
 FOREIGN KEY (oab_advogado) REFERENCES advogado(oab));

 ALTER TABLE reclamante ADD (
 FOREIGN KEY (id_endereco) REFERENCES endereco(id));


CREATE TABLE juiz (
    oab                 varchar2(8)   NOT NULL,
    nome                varchar2(200) NOT NULL,
    PRIMARY KEY (oab)
);

CREATE TABLE reu (
    cpf                 varchar2(11)  NOT NULL,
    nome                varchar2(200) NOT NULL,
    telefone            varchar2(15)          ,
    oab_advogado        varchar2(8)           ,
    id_endereco         integer       NOT NULL,
    PRIMARY KEY (cpf)
);

ALTER TABLE reu ADD (
 FOREIGN KEY (oab_advogado) REFERENCES advogado(oab));

ALTER TABLE reu ADD (
 FOREIGN KEY (id_endereco) REFERENCES endereco(id));

CREATE TABLE testemunha (
    cpf                 varchar2(11)  NOT NULL,
    nome                varchar2(200) NOT NULL,
    PRIMARY KEY (cpf)
);

CREATE TABLE processo (
    id                 integer       NOT NULL,
    tipo               varchar2(200) NOT NULL,
    senteca            varchar2(15),
    oab_juiz           varchar2(8)   NOT NULL,
    cpf_reu            varchar2(11)  NOT NULL,
    cpf_reclamante     varchar2(11)  NOT NULL,
    PRIMARY KEY (id)
);

ALTER TABLE processo ADD (
 FOREIGN KEY (oab_juiz) REFERENCES juiz(oab));

ALTER TABLE processo ADD (
 FOREIGN KEY (cpf_reu) REFERENCES reu(cpf));
 
ALTER TABLE processo ADD (
 FOREIGN KEY (cpf_reclamante) REFERENCES reclamante(cpf));


CREATE TABLE audiencia (
    id                 integer      NOT NULL,
    data               varchar2(20) NOT NULL,
    hora               varchar2(20) NOT NULL,
    id_processo        integer       NOT NULL,
    FOREIGN KEY (id_processo) REFERENCES processo(id),
    PRIMARY KEY (id)
);

CREATE TABLE move (
    cpf_reclamante     varchar2(11) NOT NULL,
    id_processo        integer      NOT NULL,
    FOREIGN KEY (cpf_reclamante) REFERENCES reclamante(cpf),
    FOREIGN KEY (id_processo)    REFERENCES processo  (id),
    PRIMARY KEY (cpf_reclamante, id_processo)
);

CREATE TABLE depor (
    cpf_testemunha     varchar2(11) NOT NULL,
    id_audiencia       integer      NOT NULL,
    FOREIGN KEY (cpf_testemunha) REFERENCES testemunha(cpf),
    FOREIGN KEY (id_audiencia)   REFERENCES audiencia (id),
    PRIMARY KEY (cpf_testemunha, id_audiencia)
);

CREATE TABLE testemunhar (
    cpf_testemunha     varchar2(11) NOT NULL,
    id_processo        integer      NOT NULL,
    FOREIGN KEY (cpf_testemunha) REFERENCES testemunha(cpf),
    FOREIGN KEY (id_processo)    REFERENCES processo  (id),
    PRIMARY KEY (cpf_testemunha, id_processo)
);







