CREATE OR REPLACE PROCEDURE inserirAdvogado (

    p_oab      IN advogado.oab%TYPE,
    p_nome     IN advogado.nome%TYPE) AS

BEGIN

    INSERT INTO advogado (oab, nome)
           VALUES (p_oab, p_nome);
    COMMIT;

END inserirAdvogado;

/

CREATE OR REPLACE PROCEDURE inserirEndereco (

    p_id       IN endereco.id%TYPE,
    p_rua      IN endereco.rua%TYPE,
    p_bairro   IN endereco.bairro%TYPE,
    p_numero   IN endereco.numero%TYPE,
    p_cidade   IN endereco.cidade%TYPE,
    p_estado   IN endereco.estado%TYPE) AS

BEGIN

    INSERT INTO endereco (id, rua, bairro, numero, cidade, estado)
           VALUES (p_id, p_rua, p_bairro, p_numero, p_cidade, p_estado);
    COMMIT;

END inserirEndereco;

/

CREATE OR REPLACE PROCEDURE inserirReclamante (

    p_id       IN endereco.id%TYPE,
    p_rua      IN endereco.rua%TYPE,
    p_bairro   IN endereco.bairro%TYPE,
    p_numero   IN endereco.numero%TYPE,
    p_cidade   IN endereco.cidade%TYPE,
    p_estado   IN endereco.estado%TYPE,
    p_cpf       IN reclamante.cpf%TYPE,
    p_nome      IN reclamante.nome%TYPE) AS


BEGIN

   INSERT INTO endereco (id, rua, bairro, numero, cidade, estado)
          VALUES (p_id, p_rua, p_bairro, p_numero, p_cidade, p_estado);

    INSERT INTO reclamante (cpf, nome, id_endereco)
           VALUES (p_cpf, p_nome, p_id);
     COMMIT;

END inserirReclamante;

/

CREATE OR REPLACE PROCEDURE inserirReu (

    p_id          IN endereco.id%TYPE,
    p_rua         IN endereco.rua%TYPE,
    p_bairro      IN endereco.bairro%TYPE,
    p_numero      IN endereco.numero%TYPE,
    p_cidade      IN endereco.cidade%TYPE,
    p_estado      IN endereco.estado%TYPE,

    p_cpf               IN reu.cpf%TYPE,
    p_nome              IN reu.nome%TYPE,
    p_telefone          IN reu.telefone%TYPE) AS
    
BEGIN

    INSERT INTO endereco (id, rua, bairro, numero, cidade, estado)
           VALUES (p_id, p_rua, p_bairro, p_numero, p_cidade, p_estado);

    INSERT INTO reu (cpf, nome, telefone, id_endereco)
           VALUES (p_cpf, p_nome, p_telefone, p_id);
     COMMIT;

END inserirReu;

/

CREATE OR REPLACE PROCEDURE inserirTestemunha (

    p_cpf               IN testemunha.cpf%TYPE,
    p_nome              IN testemunha.nome%TYPE) AS

BEGIN
    INSERT INTO testemunha (cpf, nome)
           VALUES (p_cpf, p_nome);
     COMMIT;

END inserirTestemunha;

/

CREATE OR REPLACE PROCEDURE inserirProcesso (

    p_id                IN processo.id%TYPE,
    p_tipo              IN processo.tipo%TYPE,
    p_oab_juiz          IN processo.oab_juiz%TYPE,
    p_cpf_reu           IN processo.cpf_reu%TYPE,
    p_cpf_reclamante    IN processo.cpf_reclamante%TYPE) AS

BEGIN
    INSERT INTO processo (id, tipo, oab_juiz, cpf_reu, cpf_reclamante)
           VALUES (p_id, p_tipo, p_oab_juiz, p_cpf_reu, p_cpf_reclamante);
     COMMIT;

END inserirProcesso;

/

CREATE OR REPLACE PROCEDURE inserirAudiencia (

    p_id                IN audiencia.id%TYPE,
    p_data              IN audiencia.data%TYPE,
    p_hora              IN audiencia.hora%TYPE,
    p_id_processo       IN audiencia.id_processo%TYPE) AS

BEGIN
    INSERT INTO audiencia (id, data, hora, id_processo)
           VALUES (p_id, p_data, p_hora, p_id_processo);
     COMMIT;

END inserirAudiencia;

/

CREATE OR REPLACE PROCEDURE inserirMove (

    p_cpf_reclamante    IN move.cpf_reclamante%TYPE,
    p_id_processo       IN move.id_processo%TYPE) AS

BEGIN
    INSERT INTO move (cpf_reclamante, id_processo)
           VALUES (p_cpf_reclamante, p_id_processo);
     COMMIT;

END inserirMove;

/

CREATE OR REPLACE PROCEDURE inserirDepor (

    p_cpf_testemunha    IN depor.cpf_testemunha%TYPE,
    p_id_audiencia      IN depor.id_audiencia%TYPE) AS

BEGIN
    INSERT INTO depor (cpf_testemunha, id_audiencia)
           VALUES (p_cpf_testemunha, p_id_audiencia);
     COMMIT;

END inserirDepor;

/

CREATE OR REPLACE PROCEDURE inserirTestemunhar (

    p_cpf_testemunha    IN testemunhar.cpf_testemunha%TYPE,
    p_id_processo       IN testemunhar.id_processo%TYPE) AS

BEGIN
    INSERT INTO testemunhar (cpf_testemunha, id_processo)
           VALUES (p_cpf_testemunha, p_id_processo);
     COMMIT;

END inserirTestemunhar;

/

