--Lista os nomes dos juizes com salario entre os valores
select nome from juiz where salario between 12000.00 and 20000.00;

--Lista os que tem nome parecido
select nome, cpf from reu where nome like 'Reu%1';

--Lista a mdia de salario dos juizes
select avg(salario) from juiz;

--Lista os valores dos salarios dos juizes
select distinct salario from juiz;

--Lista o cpf do reu que foi julgado por certo juiz
select distinct cpf_reu as Reu from processo where oab_juiz = '123451';

--Lista nome do reu, reclamante, processo, juiz
SELECT re.nome, rc.nome, p.id as Precesso, j.nome from Reu re, Reclamante rc, Processo p, Juiz j where re.cpf = p.cpf_reu and rc.cpf = p.cpf_reclamante and j.oab = p.oab_juiz group by p.id, re.nome, rc.nome,  j.nome;

--Lista os reus que moram em uma determinada rua
select nome from reu where id_endereco in (select id from endereco where rua = 'ruaC');

--Lista o juiz que julgou um determinado reu
select nome from juiz where oab in (select oab_juiz from processo where cpf_reu in (select cpf from reu where nome = 'Reu_4'));

--Lista os reus
select * from reu order by nome;

--Lista os reclamantes em ordem decressente por nome
select * from reclamante order by nome desc;

--Lista o nome e salario dos juizes que tem o salario maximo
select nome, salario from juiz where salario in(select max(salario) from juiz);
--Lista o nome e salario dos juizes que tem o menor salario
select nome, salario from juiz where salario in(select min(salario) from juiz);
--Lista a quantidade de processos de um reu
select count (*) from processo where cpf_reu = '123';

--Lista salario maximo
select max(salario) from juiz;
--Lista menor salario
select min(salario) from juiz;
--Lista media salaria
select avg(salario) from juiz;

-- Lista a quantidade de processos, o nome e o cpf do reu
select nome, cpf_reu, count (*) as qtd from processo inner join reu on cpf = cpf_reu group by nome, cpf_reu;

--Lista as datas da audiencias que tem um depoimento
select data from audiencia left outer join depor on id_audiencia = audiencia.id;
 --  LISTAR OS ENDERECOS QUE TEM ID <6
 SELECT * FROM  ENDERECO WHERE ID < 6;

  -- LISTAR OS ENDERECOS QUE TEM ID > 6
  SELECT * FROM  ENDERECO WHERE ID > 6;

  -- LISTAR OS ENDERECOS DO BAIRRO100
 SELECT * FROM  ENDERECO WHERE bairro = 'bairro100';

   -- LISTAR OS ENDERECOS DO BAIRRO3
 SELECT * FROM  ENDERECO WHERE bairro = 'bairro3';

 -- LISTAR OS ENDERECOS DO BAIRRO10
 SELECT * FROM  ENDERECO WHERE bairro = 'bairro10';
                          -- AND
  -- LISTAR OS BAIRROS DO ENDERECO QUE TEM ID ENTRE 1 E 10
 SELECT BAIRRO FROM ENDERECO WHERE ID BETWEEN 1 AND 10;

 -- LISTAR OS BAIRROS DO ENDERECO QUE NAO  TEM ID ENTRE 1 E 10
 SELECT BAIRRO FROM ENDERECO WHERE ID NOT BETWEEN 1 AND 10;

  -- LISTAR NOME E CPF  DOS  REUS ONDE O BAIRRO  NAO COMECA COM A LETRA C
 SELECT NOME, CPF  FROM REU WHERE ID_ENDERECO IN (SELECT ID FROM ENDERECO WHERE BAIRRO NOT LIKE 'C%');    --  IN NOT LIKE  SELECIONA OS  NOMES DO REU ONDE O BAIRRO NAO COMECA NEM COM A LETRA D E NEM COM A LETRA C

 -- LISTAR NOME E CPF  DOS  REUS ONDE O BAIRRO COMECA COM A LETRA B
 SELECT NOME, CPF  FROM REU WHERE ID_ENDERECO IN (SELECT ID FROM ENDERECO WHERE BAIRRO LIKE 'b%');        --  IN LIKE  SELECIONA O NOME E CPF  DE UM  CERTO BAIRRO ;

 -- LISTAR O NOME E CPF DO REU  QUE NAO TEM NUMERO DE ENDERECO
 SELECT NOME, CPF  FROM REU WHERE ID_ENDERECO IN (SELECT ID FROM ENDERECO WHERE NUMERO IS NULL);          --  IS NULL  SELECIONA O NOME E CPF DO REU  QUE NAO TEM NUMERO NO ENDERECO

 -- LISTAR O NOME E CPF DO REU  QUE TEM NUMERO DE ENDERECO
 SELECT NOME, CPF FROM REU WHERE ID_ENDERECO IN (SELECT ID FROM ENDERECO WHERE NUMERO IS NOT NULL);       --  IS NOT NULL SELECIONA O NOME E CPD DO REU QUE NAO TEM NUMERO NULO NO ENDERECO

  -- LISTAR RECLAMANTES POR NOMES
 SELECT * FROM RECLAMANTE ORDER BY NOME ;                                                                 --  ORDER BY

  -- LISTAR RECLAMANTES POR NOMES  NA ORDEM DECRESCENTE
 SELECT * FROM REU ORDER BY NOME DESC;                                                                    -- ORDER BY DESC

  -- LISTAR A CIDADE E ESTADO QUE TEM O MAIOR ID DE ENDERECO
 SELECT ID, CIDADE, ESTADO FROM ENDERECO  WHERE ID  IN (SELECT MAX (ID) FROM ENDERECO);                   --  MAX  SELECIONA   O ENDERECO DE MAIOR  ID

-- LISTAR  REU RECLAMTE E JUIZ DO  PROCESSO DE MAIR ID
 SELECT ID, CPF_REU, CPF_RECLAMANTE , OAB_JUIZ FROM PROCESSO WHERE ID IN (SELECT MAX (ID)FROM PROCESSO);

 -- LISTAR O ID E DATA DA AUDIENCIA QUE TEM O MENOR  ID DE PROCESSO
 SELECT ID, DATA, ID_PROCESSO FROM AUDIENCIA WHERE ID_PROCESSO  IN (SELECT MIN (ID)FROM PROCESSO);         -- MIN

 -- LISTAR A SOMA DOS SALARIOS DOS JUIZES
 SELECT SUM (SALARIO) FROM JUIZ;

  -- LISTAR A MEDIA DOS SALARIOS DOS JUIZES
 SELECT AVG (SALARIO) FROM JUIZ;

  -- MOSTRAR A QUANTIDADE DE  JUIZES QUE GANHAM MAIS QUE A MEDIA DOS SALARIOS
 SELECT COUNT (*) FROM JUIZ WHERE SALARIO  > (SELECT AVG (SALARIO)FROM JUIZ);                              -- COUNT AVG
 SELECT DISTINCT BAIRRO FROM ENDERECO WHERE ID NOT BETWEEN 1 AND 10;                                      -- DISTINCT  DIFERENTES BAIRROS  QUE TEM ID ESPECIFICADO

 -- LISTAR POR ORDEM DE OAB DO JUIZ , MOSTRANDO REU E RECLAMANTE
 SELECT OAB_JUIZ, CPF_REU , CPF_RECLAMANTE  FROM PROCESSO GROUP BY (OAB_JUIZ, CPF_REU, CPF_RECLAMANTE);

  -- LISTAR POR ORDEM DE PCF DO REU  MOSTRANDO JUIZ E RECLAMANTE
 SELECT  CPF_REU , CPF_RECLAMANTE , OAB_JUIZ FROM PROCESSO GROUP BY ( CPF_REU, CPF_RECLAMANTE, OAB_JUIZ);     -- GROUP BY

-- Listar o nmero total de  juizes que possuem o oab > 123450 agrupados por salario
-- mas s daqueles salarios que so recebidos por mais de 1 juiz
SELECT salario, COUNT   FROM juiz WHERE oab > 123450  GROUP BY salario HAVING COUNT  > 1;

-- LISTAR A QUANTIDADE DE JJUIZES QUE GANHAM 180000
SELECT  COUNT(*) FROM JUIZ J WHERE J.SALARIO = 18000;

-- LISTAR OAB E SALARIO DOS JUIZES  QUE GANHAM MAIS QUE 18000 USANDO ALIAS
SELECT J.OAB, J.SALARIO FROM JUIZ J WHERE J.SALARIO > 18000;

-- LISTAR O NOME E CPF DO REU QUE RESIDE NUM ID DE  ENDERECO MAIRO QUE 16
SELECT R.CPF, R.NOME , E.RUA, E.BAIRRO, E.CIDADE FROM REU R, ENDERECO E WHERE R.ID_ENDERECO = E.ID AND  E.ID < 16;

   -- LISTAR O NOME E CPF DOSS  RECLAMANTES QUE MORAM NO BAIRRO 9
SELECT R.CPF, R.NOME , E.RUA, E.BAIRRO, E.CIDADE FROM RECLAMANTE R, ENDERECO E WHERE R.ID_ENDERECO = E.ID and E.BAIRRO = 'bairro9';
    
    -- LISTAR  DADOS DAS AUDIENCIAS QUEM TEM O JUIZ 123450
SELECT A.ID, A.DATA , A.HORA , P.ID, P.CPF_REU, P.CPF_RECLAMANTE  FROM AUDIENCIA A, PROCESSO P WHERE P.OAB_JUIZ = 123450;
    
    -- LISTAR CIDADE  E ID DE ENDERECO QUE  CPF  DO REU QUE COMECEM COM A LETRA  R ;
SELECT E.CIDADE, R.ID_ENDERECO , R.CPF  FROM ENDERECO E ,REU R WHERE E.CIDADE LIKE 'r%' ;

    -- LISTAR  O NOME DO REU E PARA CADA REU LISTAR SEU  A RUA  BAIRRO  CIDADE E ESTADO POR  ORDEM DECRESCENTE
SELECT R.NOME , E.RUA, E.BAIRRO , E.CIDADE, E.ESTADO FROM REU R, ENDERECO E WHERE R.ID_ENDERECO = E.ID ORDER BY R.NOME, E.ESTADO , E.CIDADE , E.BAIRRO DESC;

   -- LISTAR O NOME DO REU E PARA CADA REU LISTAR SUA CIDADE E  ESTADO NA ORDEM ESTADO CIDADE  E NA ORDEM CRESCENTE

SELECT R.NOME, E.CIDADE, E.ESTADO FROM REU R, ENDERECO E  WHERE  R.ID_ENDERECO = E.ID
GROUP BY R.NOME, E.ESTADO, E.CIDADE
ORDER BY R.NOME, E.ESTADO ,E.CIDADE;


 --LISTAR NOME E ENDERECO DO   REU E RECLAMANTE  DO MESMO PROCESSO  COM ID 1
 SELECT R.NOME, E.CIDADE, REC.NOME, ED.CIDADE,  P.ID FROM REU R, ENDERECO E , PROCESSO P, ENDERECO ED   , RECLAMANTE REC
 WHERE P.ID = 1
 AND P.CPF_REU = R.CPF
 AND R.ID_ENDERECO = E.ID
 AND P.CPF_RECLAMANTE = REC.CPF
 AND REC.ID_ENDERECO =ED.ID;

 -- LISTAR OS NOMES DE TODOS OS REUS E OS NOMES DO BAIRRO DE ONDE SAO RESIDENTES
SELECT REU.NOME , ENDERECO.BAIRRO FROM REU
LEFT OUTER JOIN ENDERECO
ON REU.ID_ENDERECO = ENDERECO.ID;

 -- LISTAR TODOS OS NOMES DOS BAIRROS E NOMES DOS REUS  DE QUE RESIDEEM !!!
SELECT  ENDERECO.BAIRRO, REU.NOME  FROM ENDERECO
LEFT OUTER JOIN REU
ON  REU.ID_ENDERECO = ENDERECO.ID;


 -- LISTAR OS NOMES DE TODOS OS REUS E OS NOMES DO BAIRRO DE ONDE SAO RESIDENTES  E O NOME DOS DEMAIS  BAIRROS
SELECT REU.NOME , ENDERECO.BAIRRO FROM REU
RIGHT OUTER JOIN ENDERECO
ON REU.ID_ENDERECO = ENDERECO.ID;


SELECT  ENDERECO.BAIRRO, REU.NOME  FROM ENDERECO
RIGHT OUTER JOIN REU
ON  REU.ID_ENDERECO = ENDERECO.ID;

      -- FULL
  -- LISTAR OS NOMES DE TODOS OS REUS E OS NOMES DO BAIRRO DE ONDE SAO RESIDENTES  E O NOME DOS DEMAIS  BAIRROS
SELECT REU.NOME , ENDERECO.BAIRRO FROM REU
FULL OUTER JOIN ENDERECO
ON REU.ID_ENDERECO = ENDERECO.ID;

-- LISTAR OS NOMES DE TODOS OS  BAIRROS  E O NOMES DE REU DE ONDE SAO RESIDENDENTES
SELECT  ENDERECO.BAIRRO, REU.NOME  FROM ENDERECO
FULL OUTER JOIN REU
ON  REU.ID_ENDERECO = ENDERECO.ID;



-- MAIS DE UM NIVEL DE ANINHAMENTO
-- LISTAR O CPF DOS RECLAMANTES  QUE TEM EM SEU PROCESSO  JUIZ QUE GANHA 15000
SELECT CPF_RECLAMANTE , OAB_JUIZ FROM PROCESSO WHERE OAB_JUIZ IN
      (SELECT OAB FROM JUIZ  WHERE SALARIO = 15000);



-- LISTAR NOME  DOS RECLAMANTES QUE TEM EM SEU PROCESSO JUIZ QUE GANHA 15000
 SELECT NOME  FROM RECLAMANTE  WHERE CPF IN  (SELECT CPF_RECLAMANTE FROM PROCESSO WHERE OAB_JUIZ IN
      (SELECT OAB FROM JUIZ  WHERE SALARIO = 15000));
      
      
  -- LISTAR O NOME E OAB DOS JUIZES  CUJO SALARIO - 7000 EH MAIOR QUE PELO MENOS O MENOR DOS SALARIOS
 SELECT NOME, OAB , SALARIO FROM JUIZ WHERE SALARIO -7000  >
    SOME (SELECT MIN (SALARIO) FROM JUIZ );
    

  --  LISTAR O NOME E OAB DOS JUIZES  CUJO SALARIO ACRESCIDO DE 2000 EH MAIOR QUE ALGUM SALARIO DOS JUIZ QUE ESTA ENTRE 18000 E 24000
  SELECT NOME, OAB , SALARIO FROM JUIZ WHERE SALARIO  + 2000  >
    ANY (SELECT SALARIO FROM JUIZ  WHERE SALARIO BETWEEN 18000 AND 24000  );
    
  -- LIST  OS NOMES CUJO SALARIO SAO MAIORES QUE OS SALARIO DE TODOS OS JUIZES COMMPREENDIDO EMTRE 14000 E 17000
  SELECT NOME, SALARIO FROM JUIZ WHERE SALARIO > ALL (SELECT SALARIO FROM JUIZ WHERE SALARIO BETWEEN 14000 AND 17000);

  -- LISTAR TODOS  OS NOME E CPF DE REUS QUE MORAM NO BAIRRO10
  SELECT NOME , CPF 
  FROM REU R  WHERE EXISTS
  ( SELECT * FROM ENDERECO E
     WHERE  R.ID_ENDERECO = E.ID
     AND E.BAIRRO = 'bairro10'
  );
  
  -- listar os  id  de enderecos  dos  reus  e dos reclamantes
  (SELECT ID_ENDERECO  FROM REU )
  UNION (SELECT ID_ENDERECO FROM RECLAMANTE);

  -- LISTAR TODAS AS RUAS QUEM TEM REU E RECLAMANTE
(SELECT E.RUA FROM  ENDERECO E , REU R WHERE (R.ID_ENDERECO = E.ID))
INTERSECT
  (SELECT E.RUA FROM ENDERECO E , RECLAMANTE RE WHERE ( RE.ID_ENDERECO = E.ID));

   -- LISTAR TODAS AS CIDADES  QUE  REU E RECLAMANTE     INTERSECT
(SELECT E.CIDADE FROM  ENDERECO E , REU R WHERE (R.ID_ENDERECO = E.ID))
INTERSECT
  (SELECT E.CIDADE FROM ENDERECO E , RECLAMANTE RE WHERE ( RE.ID_ENDERECO = E.ID));

    -- LISTAR TODOS  OS CIDADE QUE TEM REU MAS NAO MORAM RECLAMANTE    EXECPT
(SELECT E.CIDADE FROM  ENDERECO E , REU R WHERE (R.ID_ENDERECO = E.ID))
MINUS
  (SELECT E.CIDADE FROM ENDERECO E , RECLAMANTE RE WHERE ( RE.ID_ENDERECO = E.ID));
  
  -- CONCEDER PERMISSAO DE CONSULTA DA TABELA MOVE PRA USUARIA DA EQUIPE 10
  GRANT SELECT ON TESTEMUNHA TO g071if685_eq10 ;
  
  -- CONCEDER PERMISSAO DE INSERCAO DA TABELA TESTEMUNHA PRA EQUIPE 10
  GRANT INSERT ON TESTEMUNHA TO g071if685_eq10 ;
  
   -- CONCEDER PERMISSAO DE UDPATE DA TABELA TESTEMUNHA PRA EQUIPE 10
  GRANT UPDATE ON TESTEMUNHA TO g071if685_eq10 ;
   
    -- CONCEDER PERMISSAO DE DELETE DA TABELA TESTEMUNHA PRA EQUIPE 10
  GRANT DELETE ON TESTEMUNHA TO g071if685_eq10 ;

   -- CONCEDER TODOS PRIVILEGIOS  DA TABELA TESTEMUNHA PRA EQUIPE 10
 GRANT ALL PRIVILEGES ON TESTEMUNHA TO g071if685_eq10 ;

     -- CONCEDER PERMISSAO DE CONSULTA DA TABELA TESTEMUNHA PARA TODOS
   GRANT SELECT ON TESTEMUNHA TO PUBLIC ;

   -- REMOVER O PRIVILEGIO DE CONSULTA 
   REVOKE  SELECT ON TESTEMUNHA TO g071if685_eq10 ;

-- REMOVER O PRIVILEGIO DE INSERCAO
  REVOKE  INSERT ON TESTEMUNHA TO g071if685_eq10 ;
 -- REMOVER O PRIVILEGIO DE UDPADE
  REVOKE  UPDATE ON TESTEMUNHA TO g071if685_eq10 ;
-- REMOVER O PRIVILEGIO DE DELETAR
   REVOKE  DELETE ON TESTEMUNHA TO g071if685_eq10 ;
 -- REMOVER TODOS OS PRIVILEGIOS
 REVOKE  ALL PRIVILEGES ON TESTEMUNHA TO g071if685_eq10 ;

-- REMOVER O PRIVILEGIO DE CONSULTA
 REVOKE  SELECT ON TESTEMUNHA TO PUBLIC ;



